# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.257
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class GroupReconciliationUserReview(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'break_codes': 'list[GroupReconciliationUserReviewBreakCode]',
        'match_keys': 'list[GroupReconciliationUserReviewMatchKey]',
        'comments': 'list[GroupReconciliationUserReviewComment]'
    }

    attribute_map = {
        'break_codes': 'breakCodes',
        'match_keys': 'matchKeys',
        'comments': 'comments'
    }

    required_map = {
        'break_codes': 'optional',
        'match_keys': 'optional',
        'comments': 'optional'
    }

    def __init__(self, break_codes=None, match_keys=None, comments=None, local_vars_configuration=None):  # noqa: E501
        """GroupReconciliationUserReview - a model defined in OpenAPI"
        
        :param break_codes:  A list of break codes shared between the reconciliation runs of the same run instance and result hash.
        :type break_codes: list[lusid.GroupReconciliationUserReviewBreakCode]
        :param match_keys:  A list of match keys shared between the reconciliation runs of the same run instance and result hash.
        :type match_keys: list[lusid.GroupReconciliationUserReviewMatchKey]
        :param comments:  A list of comments shared between the reconciliation runs of the same run instance and result hash.
        :type comments: list[lusid.GroupReconciliationUserReviewComment]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._break_codes = None
        self._match_keys = None
        self._comments = None
        self.discriminator = None

        self.break_codes = break_codes
        self.match_keys = match_keys
        self.comments = comments

    @property
    def break_codes(self):
        """Gets the break_codes of this GroupReconciliationUserReview.  # noqa: E501

        A list of break codes shared between the reconciliation runs of the same run instance and result hash.  # noqa: E501

        :return: The break_codes of this GroupReconciliationUserReview.  # noqa: E501
        :rtype: list[lusid.GroupReconciliationUserReviewBreakCode]
        """
        return self._break_codes

    @break_codes.setter
    def break_codes(self, break_codes):
        """Sets the break_codes of this GroupReconciliationUserReview.

        A list of break codes shared between the reconciliation runs of the same run instance and result hash.  # noqa: E501

        :param break_codes: The break_codes of this GroupReconciliationUserReview.  # noqa: E501
        :type break_codes: list[lusid.GroupReconciliationUserReviewBreakCode]
        """

        self._break_codes = break_codes

    @property
    def match_keys(self):
        """Gets the match_keys of this GroupReconciliationUserReview.  # noqa: E501

        A list of match keys shared between the reconciliation runs of the same run instance and result hash.  # noqa: E501

        :return: The match_keys of this GroupReconciliationUserReview.  # noqa: E501
        :rtype: list[lusid.GroupReconciliationUserReviewMatchKey]
        """
        return self._match_keys

    @match_keys.setter
    def match_keys(self, match_keys):
        """Sets the match_keys of this GroupReconciliationUserReview.

        A list of match keys shared between the reconciliation runs of the same run instance and result hash.  # noqa: E501

        :param match_keys: The match_keys of this GroupReconciliationUserReview.  # noqa: E501
        :type match_keys: list[lusid.GroupReconciliationUserReviewMatchKey]
        """

        self._match_keys = match_keys

    @property
    def comments(self):
        """Gets the comments of this GroupReconciliationUserReview.  # noqa: E501

        A list of comments shared between the reconciliation runs of the same run instance and result hash.  # noqa: E501

        :return: The comments of this GroupReconciliationUserReview.  # noqa: E501
        :rtype: list[lusid.GroupReconciliationUserReviewComment]
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this GroupReconciliationUserReview.

        A list of comments shared between the reconciliation runs of the same run instance and result hash.  # noqa: E501

        :param comments: The comments of this GroupReconciliationUserReview.  # noqa: E501
        :type comments: list[lusid.GroupReconciliationUserReviewComment]
        """

        self._comments = comments

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GroupReconciliationUserReview):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GroupReconciliationUserReview):
            return True

        return self.to_dict() != other.to_dict()
